<template>
  <article class="post-page">
    <div class="thumbnail" :style="{backgroundImage: `url(${baseUrl}/${post.thumbnail})`}"></div>
    <div class="body">
      <LinedComponent>
        <h1 class="title">{{ post.title }}</h1>
        <h2 class="subtitle">{{ post.short_description }}</h2>
      </LinedComponent>
      <div class="description" v-html="post.description"></div>
      <p class="footer">
        نوشته شده توسط {{ post.user.name || post.user.username }} در {{ post.created_at }}
      </p>
    </div>
  </article>
</template>

<script>
import LinedComponent from "@/components/base/LinedComponent";

export default {
  components: {
    LinedComponent
  },
  async asyncData(context) {
    let post = {};
    await context.store.dispatch('blog/fetchPost', context.route.params.id).then(response => {
      post = response.data.data;
    }).catch(error => {
      console.log(error);
    });
    return {
      post
    }
  },
  data() {
    return {
      baseUrl: process.env.baseUrl
    }
  },
  head() {
    return {
      title: this.post.title
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables";

.post-page
  background-color $black
  color $white
  direction rtl

.body
  margin-top 75vh
  box-shadow 0 -1rem 2.5rem rgba(black, .4)
  padding $xlg $lg
  @media only screen and (max-width 600px)
    padding $lg $md
  @media only screen and (max-width 500px)
    padding $md $md

.title
  font-size 4.5rem
  font-weight 400
  margin-bottom 0
  @media only screen and (max-width 600px)
    font-size 4rem
  @media only screen and (max-width 500px)
    font-size 3rem

.subtitle
  font-size 2rem
  margin 0
  @media only screen and (max-width 500px)
    font-size 1.8rem

.description
  font-size 1.8rem
  font-weight 300
  line-height 4rem
  @media only screen and (max-width 500px)
    font-size 1.6rem

>>> p
  &:not(:last-of-type)
    margin-bottom $sm
  &:first-child
    margin-top $md

>>> h2
  font-size 3rem
  font-weight 300
  margin-top $lg
  margin-bottom $md
  @media only screen and (max-width 500px)
    font-size 2.5rem

.thumbnail
  width 100vw
  height 75vh
  background-size cover
  background-position center
  position fixed
  z-index -1
  top 0
  left 0
  

.footer
  font-size 1.6rem
  opacity .5
  margin-top $md
  @media only screen and (max-width 500px)
    font-size 1.4rem
</style>